
&& md5Bits
&& (c) Gregory Adam 2008
*===============================================================================
#include	"FoxPro.h"
#define		TRUE	.t.
#define		FALSE	.f.
*===============================================================================
*---------------------------------------------------------------------------
#define MD5BITS_CLASS	'md5Bits'
*---------------------------------------------------------------------------

*---------------------------------------------------------------------------
function md5Bits_Object(obj)
	
	obj = null
	try
		obj = CreateObject(MD5BITS_CLASS)
	endtry
	
	return inlist(vartype(m.obj), T_OBJECT)
	

endfunc
*-------------------------------------------------------------------------------
#if FALSE
	functions
		- Update(string)
		- final(@m.Digest)
		
		- DigestString(string, @Digest)
		- DigestFile(FileName, @m.Digest)

#endif
#define TESTSUITE_COMPILE	FALSE

#if TESTSUITE_COMPILE
function md5_test()

	local obj
	assert md5Bits_Object(@m.obj)
	assert m.obj.TestSuite()
endfunc
#endif
*-------------------------------------------------------------------------------
function ath(s)	&& ascii to hex
	return strconv(m.s, 15)
endfunc
*--------------------------------------------------------------------------------
function hta(s)	&&  hex to ascii
	return strconv(m.s, 16)
endfunc
*--------------------------------------------------------------------------------

*===============================================================================
*===============================================================================
*===============================================================================
#define MD5STRUCTLENGTH	(104) &&  2*4 + 4*4 + 64 + 16

#define MD5_FILEREAD_BUFSIZ	(8192)

define class MD5BITS_CLASS as relation
	
	md5struct = space(MD5STRUCTLENGTH)
	
*-------------------------------------------------------------------------------
protected function init()

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case !DoDefault()
		assert FALSE
		Success = FALSE
	
	case !m.this.Declares()
		assert FALSE
		Success = FALSE
		
	case !m.this.md5_init()
		assert FALSE
		Success = FALSE
		
	endcase
		
	return m.Success
endfunc
*-------------------------------------------------------------------------------
protected function md5_init()
	
	local md5struct
	store m.this.md5struct to md5struct
	= md5init(@m.md5struct)
	store m.md5struct to this.md5struct
endfunc
*--------------------------------------------------------------------------------
function Update(s)
	
	local md5struct
	store m.this.md5struct to md5struct
	=md5Update(@m.md5struct, @m.s, len(m.s))
	store m.md5struct to this.md5struct
	
endfunc
*--------------------------------------------------------------------------------
function final(Digest)
	
	local md5struct
	store m.this.md5struct to md5struct
	=MD5Final(@m.md5struct)
	
	Digest = substr(m.md5struct, 89)
	=m.this.md5_init()
endfunc
*-------------------------------------------------------------------------------
function DigestString(s, Digest)
	
	return m.this.Update(@m.s) and m.this.Final(@m.Digest)
endfunc
*-------------------------------------------------------------------------------
function DigestFile(FileName, Digest)
	
	with m.this
		local fd, i, FileSize
		
		fd = fopen(m.FileName)
		
		if( m.fd < 0 ) 
			return FALSE
		endif
		
		
		FileSize = fseek(m.fd, 0, 2)
		=fseek(m.fd, 0, 0)
		
		
		for i = 1 to int(m.FileSize /MD5_FILEREAD_BUFSIZ)
			if( !.update(fread(m.fd, MD5_FILEREAD_BUFSIZ)) )
				assert FALSE
				=fclose(m.fd)
				return FALSE
			endif
		endfor
		
		=empty(mod(m.FileSize, MD5_FILEREAD_BUFSIZ)) or .update(fread(m.fd, MD5_FILEREAD_BUFSIZ))
		
		=fclose(m.fd)
		
		= .final(@m.Digest)
	
	
	endwith
endfunc
*--------------------------------------------------------------------------------
protected function Declares()
	
	local Success
	Success = TRUE
	
	try
		declare MD5Init in Cryptdll.dll ;
			string @Context
			
		declare MD5Update in Cryptdll.dll ;
			string @Context, ;
			string @Input, ;
			long inputlen 
		
		declare MD5Final in Cryptdll.dll ;
			string @Context

	catch
		assert FALSE
		Success = FALSE
	
	endtry 
	return m.Success

endfunc
*--------------------------------------------------------------------------------
*-------------------------------------------------------------------------------

*--------------------------------------------------------------------------------
#if TESTSUITE_COMPILE
*--------------------------------------------------------------------------------
function TestSuite()
	
	Local Success
	Success = TRUE
	
	with m.this
	
		do case
		case !m.Success
#if TRUE		
		case !.TestString("", "d41d8cd98f00b204e9800998ecf8427e")
			assert FALSE
			Success = FALSE
			
		case !.TestString("a", "0cc175b9c0f1b6a831c399e269772661")
			assert FALSE
			Success = FALSE
			
		case !.TestString("abc", "900150983cd24fb0d6963f7d28e17f72")
			assert FALSE
			Success = FALSE
		
		case !.TestString("message digest", "f96b697d7cb7938d525a2f31aaf161d0")
			assert FALSE
			Success = FALSE
		
		case !.TestString("abcdefghijklmnopqrstuvwxyz", "c3fcd3d76192e4007dfb496cca67e13b")
			assert FALSE
			Success = FALSE
#endif		
		case !.TestString("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", ;
							 "d174ab98d277d9f5a5611c2c9f419d9f")
			assert FALSE
			Success = FALSE
		
		case !.TestString("12345678901234567890123456789012345678901234567890123456789012345678901234567890", ;
				"57edf4a22be3c955ac49da2e2107b67a")
		
			assert FALSE
			Success = FALSE
		
		endcase
	
	endwith
	
	return m.Success
endfunc
*--------------------------------------------------------------------------------
function TestString(Input, Output)

	local Digest
	
	=this.DigestString(Input, @Digest)
	Digest = ath(m.Digest)
	
	acti screen
	do case
	case upper(m.Digest) == upper(m.Output)
		? 'OK', Input, output
		
		return TRUE
	otherwise
		? 'Fail', Input
		? 'exp ', upper(Output)
		? 'got ', upper(Digest)

		return FALSE
	endcase
endfunc
*--------------------------------------------------------------------------------
#endif
enddefine
*===============================================================================
*===============================================================================
*===============================================================================